<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  admin_global_settings.php                                ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                               ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/friendly_functions.php");

	check_admin_security("site_settings");

	// additional connection 
	$dbs = new VA_SQL();
	$dbs->DBType      = $db_type;
	$dbs->DBDatabase  = $db_name;
	$dbs->DBUser      = $db_user;
	$dbs->DBPassword  = $db_password;
	$dbs->DBHost      = $db_host;
	$dbs->DBPort      = $db_port;
	$dbs->DBPersistent= $db_persistent;

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_global_settings.html");

	$t->set_var("admin_global_settings_href", "admin_global_settings.php");
	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_layout_scheme_href", "admin_layout_scheme.php");

	include("./admin_header.php");
	include("./admin_footer.php");

	$r = new VA_Record($table_prefix . "global_settings");

	// load data to listbox
	$countries = get_db_values("SELECT country_code,country_name FROM " . $table_prefix . "countries ORDER BY country_order ", array(array("", "")));
	$states = get_db_values("SELECT state_code, state_name FROM " . $table_prefix . "states ORDER BY state_name ", array(array("", "")));
	$admin_templates_dir_values = get_db_values("SELECT layout_id,layout_name FROM " . $table_prefix . "layouts", "");

	$records_per_page = 
		array( 
			array(5, 5), array(10, 10), array(15, 15),
			array(20, 20), array(25, 25), array(50, 50),
			array(75, 75), array(100, 100)
			);


	$yes_no = 
		array( 
			array(1, YES_MSG), array(0, NO_MSG)
			);

	$password_encrypt = 
		array( 
			array(0, "None"), 
			array(1, "Use MD5 for encryption (if you choose this option all passwords in the database will be encrypted)")
			);


	$html_editors = 
		array( 
			array(1, "WYSIWYG HTML Editor"),
			array(0, "Textarea Editor")
			);


	// set up parameters
	$r->add_textbox("site_url", TEXT);
	$r->add_textbox("admin_email", TEXT);
	$r->add_select("country_code", TEXT, $countries);
	$r->add_select("state_code", TEXT, $states);
	$r->add_select("layout_id", INTEGER, $admin_templates_dir_values);
	$r->add_radio("password_encrypt", INTEGER, $password_encrypt);
	$r->change_property("password_encrypt", BEFORE_SHOW_VALUE, "disable_password_encrypt");
	$r->add_textbox("weight_measure", TEXT);

	// text editor settings
	$r->add_radio("html_editor", INTEGER, $html_editors);
	$r->add_checkbox("user_image_upload", INTEGER);
	$r->add_textbox("user_image_size", INTEGER);
	$r->add_textbox("user_image_width", INTEGER);
	$r->add_textbox("user_image_height", INTEGER);

	$r->add_textbox("secure_url", TEXT);
	$r->add_checkbox("secure_user_profile", INTEGER);

	{
		$r->add_checkbox("secure_order_profile", INTEGER);
		$r->add_checkbox("secure_payments", INTEGER);
	}

	$r->add_checkbox("secure_admin_login", INTEGER);


	// tracking fields
	$r->add_checkbox("tracking_visits", INTEGER);
	$r->add_checkbox("tracking_pages", INTEGER);
	$r->add_checkbox("google_analytics", INTEGER);
	$r->add_textbox("google_tracking_code", TEXT);

	$r->add_radio("approve_review", INTEGER, $yes_no);
	$r->add_select("reviews_per_page", INTEGER, $records_per_page);
	

	$r->add_textbox("min_rating", FLOAT);
	$r->add_textbox("min_votes", INTEGER);

	$r->add_textbox("index_title", TEXT);
	$r->add_textbox("index_description", TEXT);
	$r->add_textbox("index_keywords", TEXT);
	$r->add_textbox("html_on_index", TEXT);
	$r->add_textbox("html_below_footer", TEXT);

	$r->get_form_values();

	$site_url = $r->get_value("site_url");
	if(strlen($site_url) && substr($site_url, strlen($site_url) - 1) != "/") {
		$site_url .= "/";
    $r->set_value("site_url", $site_url);
	}

	$operation = get_param("operation");
	$return_page = get_param("rp");
	if(!strlen($return_page)) $return_page = "admin.php";
	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}

		$is_valid = $r->validate();

		if(!strlen($r->errors))
		{
			$sql  = " SELECT setting_value FROM " . $table_prefix . "global_settings ";
			$sql .= " WHERE setting_type='global' AND setting_name='password_encrypt' ";
			$old_password_encrypt = get_db_value($sql);
			$new_password_encrypt = $r->get_value("password_encrypt");

			$sql  = " SELECT setting_value FROM " . $table_prefix . "global_settings ";
			

			$sql = "DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='global'";
			$db->query($sql);
			foreach($r->parameters as $key => $value)
			{
				$sql  = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES (";
				$sql .= "'global', '" . $key . "'," . $db->tosql($value[CONTROL_VALUE], TEXT) . ")";
				$db->query($sql);
			}
			set_session("session_settings", "");
			session_unregister("session_settings");

			// check if password encrypt setting was changed to md5
			if ($new_password_encrypt == 1 && $new_password_encrypt != $old_password_encrypt) {
				$sql  = " SELECT user_id, password FROM " . $table_prefix . "users ";
				$db->query($sql);
				while($db->next_record()) {
					$user_id = $db->f("user_id");
					$password = $db->f("password");
					if (!preg_match("/[0-9a-f]{32}/i", $password)) {
						$sql  = " UPDATE " . $table_prefix . "users SET ";
						$sql .= " password=" . $db->tosql(md5($password), TEXT);
						$sql .= " WHERE user_id=" . $db->tosql($user_id, INTEGER);
						$dbs->query($sql);
					}
				}

				$sql  = " SELECT admin_id, password FROM " . $table_prefix . "admins ";
				$db->query($sql);
				while($db->next_record()) {
					$admin_id = $db->f("admin_id");
					$password = $db->f("password");
					if (!preg_match("/[0-9a-f]{32}/i", $password)) {
						$sql  = " UPDATE " . $table_prefix . "admins SET ";
						$sql .= " password=" . $db->tosql(md5($password), TEXT);
						$sql .= " WHERE admin_id=" . $db->tosql($admin_id, INTEGER);
						$dbs->query($sql);
					
					}
				}
			}

			header("Location: " . $return_page);
			exit;
		}
	}
	else // get global settings
	{
		foreach($r->parameters as $key => $value)
		{
			$sql  = "SELECT setting_value FROM " . $table_prefix . "global_settings ";
			$sql .= "WHERE setting_type='global' AND setting_name='" . $key . "'";
			$r->set_value($key, get_db_value($sql));
		}
	}

	$r->set_parameters();
	$t->set_var("rp", htmlspecialchars($return_page));

	$layout_scheme = "";
	$active_layout_id = $settings["layout_id"];
	$sql = " SELECT layout_name FROM " . $table_prefix . "layouts WHERE layout_id=" . $db->tosql($active_layout_id, INTEGER);
	$db->query($sql);
	if($db->next_record()) {
		$layout_lc = strtolower($db->f("layout_name"));
		if ($dir = @opendir($root_folder_path . "styles")) 
		{
			$dir_values = array();
		  while($file = readdir($dir)) {
				if ( preg_match("/^" . $layout_lc . "\_/", $file) ) { 
					$dir_values[] = $file;
		    } 
		  }  
  		closedir($dir);
			if(sizeof($dir_values) > 1) {
				$layout_scheme = "<a href=\"#\" onCLick=\"window.location='admin_layout_scheme.php'; return false;\">Change Active Scheme</a>";
			}
		}
	}
	$t->set_var("layout_scheme", $layout_scheme);

	$t->pparse("main");

	function disable_password_encrypt($parameters)
	{
		global $r, $t;
		$current_value = $parameters["current_value"];
		if ($r->get_value("password_encrypt") == 1) {
			if ($current_value == "1") {
				$t->set_var("password_encrypt_disabled", "");
			} else {
				$t->set_var("password_encrypt_disabled", "disabled");
			}
		} else {
			$t->set_var("password_encrypt_disabled", "");
		}

	}

?>