<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  admin_menu.php                                           ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/sorter.php");
	include($root_folder_path . "includes/navigator.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("layouts");

	$layout_id   = get_param("layout_id");
	$set_default = get_param("set_default"); //-- set this view by default

	//-- switch to default view 
	if ((@$settings["admin_layout_view"] == "datasheet") && $layout_id && !$set_default) {
		header("Location: admin_layout_header.php?layout_id=$layout_id");
		exit;
	}

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_menu.html");
	

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_page_href", "admin_menu.php?layout_id=".$layout_id);
	$t->set_var("admin_layout_href", "admin_layout.php");	
	$t->set_var("save_button", "Add New");
	
	$r = new VA_Record($table_prefix . "menus");
	$r->return_page = "admin_layouts.php";

	$r->add_where("menu_id", INTEGER);
	$r->add_textbox("menu_title", TEXT, "Menu Title");
	$r->add_textbox("menu_name", TEXT, "Name");
	$r->add_textbox("menu_notes", TEXT, "Notes");
	$r->change_property("menu_title", REQUIRED, true);
	$r->change_property("menu_name", REQUIRED, true);
	$r->set_event(BEFORE_DELETE, "delete_menu_items");

	$r->process();

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");
	
	/**
	 * Remove items of the removed menu
	 *
	 */
	function delete_menu_items() {
		global $db, $r, $table_prefix;
		$menu_id = $r->get_value("menu_id");
		if (intval($menu_id) > 0) {
			$sql = "DELETE FROM ".$table_prefix."menus_items ";
			$sql .= "WHERE menu_id = ".$db->tosql($menu_id, INTEGER);
			
			$db->query($sql);
		}
	}
?>