<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  admin_order_serial.php                                   ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                 ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/sorter.php");
	include($root_folder_path . "includes/navigator.php");

	check_admin_security("sales_orders");
	check_admin_security("order_serials");

	$operation = get_param("operation");
	$order_id  = get_param("order_id");
	$serial_id = get_param("serial_id");
	if (strlen($serial_id) && !strlen($order_id)) {
		$sql  = " SELECT order_id FROM " . $table_prefix . "orders_items_serials WHERE serial_id=" . $db->tosql($serial_id, INTEGER);
		$order_id = get_db_value($sql);
	}

	$date_format_msg = str_replace("{date_format}", join("", $datetime_edit_format), DATE_FORMAT_MSG);

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_order_serial.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_orders_href", "admin_orders.php");
	$t->set_var("admin_order_href", "admin_order.php");
	$t->set_var("admin_order_serial_href", "admin_order_serial.php");
	$t->set_var("admin_order_serials_href", "admin_order_serials.php");
	$t->set_var("admin_order_activation_href", "admin_order_activation.php");
	$t->set_var("date_format_msg", $date_format_msg);

	$r = new VA_Record($table_prefix . "orders_items_serials");
	$r->return_page = "admin_order_serials.php?order_id=" . $order_id;

	$sql  = " SELECT order_item_id,item_name FROM " . $table_prefix . "orders_items oi ";
	$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
	$items = get_db_values($sql, array(array("", "")));

	$sql  = " SELECT user_id FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, INTEGER);
	$user_id = get_db_value($sql);

	$defaul_serial_number = "";
	if (!strlen($serial_id) && !strlen($operation)) {
		while ($defaul_serial_number == "") 
		{
			$random_value  = mt_rand();
			$serial_hash   = strtoupper(md5($order_id . $random_value . va_timestamp()));
			$defaul_serial_number = substr($serial_hash,0,4)."-".substr($serial_hash,4,4)."-".substr($serial_hash,8,4)."-".substr($serial_hash,12,4);
			$sql = " SELECT serial_id FROM " .$table_prefix. "orders_items_serials WHERE serial_number=" . $db->tosql($defaul_serial_number, TEXT);
			$db->query($sql);
			if ($db->next_record()) {
				$defaul_serial_number = "";
			}
		}
	}


	$r->add_where("serial_id", INTEGER);
	$r->add_textbox("order_id", INTEGER);
	$r->parameters["order_id"][USE_IN_UPDATE] = false;
	$r->parameters["order_id"][REQUIRED] = true;
	$r->parameters["order_id"][DEFAULT_VALUE] = $order_id;
	$r->add_textbox("user_id", INTEGER);
	$r->parameters["user_id"][USE_IN_UPDATE] = false;
	$r->parameters["user_id"][REQUIRED] = true;
	$r->parameters["user_id"][DEFAULT_VALUE] = $user_id;
	$r->add_select("order_item_id", INTEGER, $items, "Product");
	$r->parameters["order_item_id"][REQUIRED] = true;
	$r->add_textbox("item_id", INTEGER);
	$r->add_textbox("serial_number", TEXT, "Serial Number");
	$r->parameters["serial_number"][REQUIRED] = true;
	$r->parameters["serial_number"][UNIQUE] = true;
	$r->parameters["serial_number"][DEFAULT_VALUE] = $defaul_serial_number;
	$r->add_textbox("serial_added", DATETIME, "Date Added");
	$r->parameters["serial_added"][REQUIRED] = true;
	$r->parameters["serial_added"][VALUE_MASK] = $datetime_edit_format;
	$r->parameters["serial_added"][DEFAULT_VALUE] = va_time();
	$r->add_checkbox("activated", INTEGER);
	$r->add_textbox("activations_number", INTEGER);
	$r->set_event(BEFORE_INSERT, "set_serial_params");
	$r->set_event(BEFORE_UPDATE, "set_serial_params");

	$r->process();

	$s = new VA_Sorter($settings["admin_templates_dir"], "sorter_img.html", "admin_order_serial.php");
	$s->set_default_sorting(2, "desc");
	$s->set_sorter("Generation Key", "sorter_generation_key", 1, "generation_key");
	$s->set_sorter("Activation Key", "sorter_activation_key", 2, "activation_key");
	$s->set_sorter("Date", "sorter_date_added", 3, "date_added");
	$s->set_sorter("Remote Address", "sorter_remote_address", 4, "remote_address");

	$n = new VA_Navigator($settings["admin_templates_dir"], "navigator.html", "admin_order_serial.php");

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "orders_serials_activations WHERE serial_id=" . $db->tosql($serial_id, INTEGER));
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;
	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);

	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$db->query("SELECT * FROM " . $table_prefix . "orders_serials_activations WHERE serial_id=" . $db->tosql($serial_id, INTEGER) . $s->order_by);
	if($db->next_record())
	{
		$t->set_var("no_records", "");
		$t->parse("sorters", false);
		do
		{
			$date_added = $db->f("date_added", DATETIME);
			$t->set_var("date_added", va_date($datetime_show_format, $date_added));
			$t->set_var("activation_id", $db->f("activation_id"));
			$t->set_var("remote_address", $db->f("remote_address"));
			$t->set_var("generation_key", $db->f("generation_key"));
			$t->set_var("activation_key", $db->f("activation_key"));
			$t->set_var("remote_address", $db->f("remote_address"));

			$t->parse("records", true);
		} while($db->next_record());
	}
	else
	{
		$t->set_var("records", "");
		$t->set_var("navigator", "");
		$t->parse("no_records", false);
	}


	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

	function set_serial_params() {
		global $db, $r;
		global $table_prefix;

		$order_item_id = $r->get_value("order_item_id");
		$sql = " SELECT item_id FROM " . $table_prefix . "orders_items WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER);
		$db->query($sql);
		if($db->next_record()) {
			$r->set_value("item_id", $db->f("item_id"));
		}
	}

?>