<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  common_functions.php                                     ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


function get_query_string($variables, $remove_parameters, $query_string = "", $set_hidden_parameters = false)
{
	global $t;

	if(is_array($variables))
	{
		$hidden_parameters = "";
		reset($variables);
		while(list($key, $value) = each($variables)) {
			$remove = false;
			if (is_array($remove_parameters)) {
				for($i = 0; $i < sizeof($remove_parameters); $i++) {
					if($key == $remove_parameters[$i]) {
						$remove = true;
						break;
					}
				}
			} else if($key == $remove_parameters) {
				$remove = true;
			}
  
			if (!$remove && strlen($value)) {
				$query_string .= strlen($query_string) ? "&" : "";
				$query_string .= $key . "=" . urlencode($value);
				if ($set_hidden_parameters) {
					$hidden_parameters .= "<input type=\"hidden\" name=\"$key\" value=\"";
					$hidden_parameters .= htmlspecialchars($value) . "\">";
				}
			}
		}
		if ($set_hidden_parameters) {
			$t->set_var("hidden_parameters", $hidden_parameters);
		}
	}

	if($query_string) {$query_string = "?" . $query_string; }

	return $query_string;
}

function get_transfer_params($remove_parameters = "")
{
	$pass_parameters = array();
	$available_params = array(
		"search_string", "category_id", "search_category_id", "item_id", "article_id",
		"s_tit", "s_cod", "s_sds", "s_fds", "manf", "user", "lprice", "hprice",
		"lweight", "hweight", "page", "sw", "sf", "forum_id", "thread_id"
	);

	for ($si = 0; $si < sizeof($available_params); $si++) {
		$param_name  = $available_params[$si];
		$param_value = get_param($param_name);
		if (strlen($param_value)) {
			$pass_parameters[$param_name] = $param_value;
		}
	}

	$pq = get_param("pq");
	$fq = get_param("fq");
	if ($pq > 0) {
		for($pi = 1; $pi <= $pq; $pi++) {
			$property_name = get_param("pn_" . $pi);
			$property_value = get_param("pv_" . $pi);
			if (strlen($property_name) && strlen($property_value)) {
				$pass_parameters["pq"] = $pq;
				$pass_parameters["pn_" . $pi] = $property_name;
				$pass_parameters["pv_" . $pi] = $property_value;
			}
		}
	}
	if ($fq > 0) {
		for($fi = 1; $fi <= $fq; $fi++) {
			$feature_name = get_param("fn_" . $fi);
			$feature_value = get_param("fv_" . $fi);
			if (strlen($feature_name) && strlen($feature_value)) {
				$pass_parameters["fq"] = $fq;
				$pass_parameters["fn_" . $fi] = $feature_name;
				$pass_parameters["fv_" . $fi] = $feature_value;
			}
		}
	}
	// check parameters to be removed
	if (is_array($remove_parameters)) {
		for ($rp = 0; $rp < sizeof($remove_parameters); $rp++) {
			$param_name = $remove_parameters[$rp];
			if (isset($pass_parameters[$param_name])) {
				unset($pass_parameters[$param_name]);
			}
		}
	}
	return $pass_parameters;
}

function transfer_params($remove_parameters, $set_hidden_parameters = false)
{
	$pass_parameters = get_transfer_params($remove_parameters);
	return get_query_string($pass_parameters, "", "", $set_hidden_parameters);
}

function get_param($param_name, $param_type = 0)
{
  global $HTTP_POST_VARS, $HTTP_GET_VARS;

  $param_value = "";
	if (isset($_POST)) {
	  if(isset($_POST[$param_name]) && $param_type != GET)
  	  $param_value = $_POST[$param_name];
	  else if(isset($_GET[$param_name]) && $param_type != POST)
  	  $param_value = $_GET[$param_name];
	} else {
	  if(isset($HTTP_POST_VARS[$param_name]) && $param_type != GET)
  	  $param_value = $HTTP_POST_VARS[$param_name];
	  else if(isset($HTTP_GET_VARS[$param_name]) && $param_type != POST)
  	  $param_value = $HTTP_GET_VARS[$param_name];
	}

  return strip($param_value);
}

function get_cookie($parameter_name)
{
  global $HTTP_COOKIE_VARS;
	if (isset($_COOKIE)) {
		return isset($_COOKIE[$parameter_name]) ? $_COOKIE[$parameter_name] : "";
	} else {
		return isset($HTTP_COOKIE_VARS[$parameter_name]) ? $HTTP_COOKIE_VARS[$parameter_name] : "";
	}
}

function get_session($parameter_name)
{
	global $HTTP_SESSION_VARS, $session_prefix;
	$parameter_name = $session_prefix . $parameter_name;
	if(isset($_SESSION)) {
	  return isset($_SESSION[$parameter_name]) ? $_SESSION[$parameter_name] : "";
	} else {
	  return isset($HTTP_SESSION_VARS[$parameter_name]) ? $HTTP_SESSION_VARS[$parameter_name] : "";
	}
}

function set_session($parameter_name, $parameter_value)
{
	global $HTTP_SESSION_VARS, $session_prefix;
	$parameter_name = $session_prefix . $parameter_name;
	if(isset($_SESSION)) {
		$_SESSION[$parameter_name] = $parameter_value;
	} else {
    global ${$parameter_name};
    if(session_is_registered($parameter_name)) 
      session_unregister($parameter_name);
    ${$parameter_name} = $parameter_value;
		$HTTP_SESSION_VARS[$parameter_name] = $parameter_value;
    session_register($parameter_name);
	}
}

function get_options($values, $selected_value)
{
	$eol = get_eol();
	$options = "";
	if(is_array($values))
	{
		for($i = 0; $i < sizeof($values); $i++)
		{	
			if($values[$i][0] == $selected_value && strlen($values[$i][0]) == strlen($selected_value))
				$selected = "selected";
			else
				$selected = "";
			$options .= "<option " . $selected;
			$options .= " value=\"" . htmlspecialchars($values[$i][0]) . "\">";
			$options .= htmlspecialchars($values[$i][1]) . "</option>". $eol;
		}
	}
	return $options;
}

function set_options($values, $value, $block_name, $events = "")
{
	global $t;
	$t->set_var($block_name, "");
	if(is_array($values))
	{
		for($i = 0; $i < sizeof($values); $i++)
		{	
			$cur_val = $values[$i][0];
			call_event($events, BEFORE_SHOW_VALUE, array("current_value" => $cur_val));
			$checked = ""; $selected = "";
			if(is_array($value)) {
				for($j = 0; $j < sizeof($value); $j++) {
					if($cur_val == $value[$j] && strlen($cur_val) == strlen($value[$j])) {
						$checked = "checked"; $selected = "selected";
						break;
					}
				}
			} else if($cur_val == $value && strlen($cur_val) == strlen($value)) {
				$checked = "checked"; $selected = "selected";
			}
			$t->set_var($block_name . "_index", ($i + 1));
			$t->set_var($block_name . "_checked", $checked);
			$t->set_var($block_name . "_selected", $selected);
			$t->set_var($block_name . "_value", htmlspecialchars($cur_val));
			$t->set_var($block_name . "_description", $values[$i][1]);
			$t->parse($block_name);
			call_event($events, AFTER_SHOW_VALUE, array("current_value" => $cur_val));
		}
	}
}

function get_ip()
{
	return get_var("REMOTE_ADDR");
}

function prepare_regexp($regexp)
{
	$escape_symbols = array("\\","/","^","\$",".","[","]","|","(",")","?","*","+","-","{","}");
	for ($i = 0; $i < sizeof($escape_symbols); $i++) {
		$regexp = str_replace($escape_symbols[$i], "\\" . $escape_symbols[$i], $regexp);
	}
	return $regexp;
}

function get_array_value($value_id, $values)
{
	$value_desc = "";
	if(is_array($values) && strlen($value_id)) {
		for($i = 0; $i < sizeof($values); $i++) {
			if($values[$i][0] == $value_id) {
				$value_desc = $values[$i][1];
				break;
			}
		}
	}
	return $value_desc;
}

function get_array_id($value_desc, $values)
{
	$value_id = "";
	if(is_array($values) && strlen($value_desc))
		for($i = 0; $i < sizeof($values); $i++)
			if($values[$i][1] == $value_desc) {
				$value_id = $values[$i][0];
				break;
			}
	return $value_id;
}


function get_db_values($sql, $values_before, $shown_symbols = 0)
{
	global $db;
	$values = array();

	$db_list = new VA_SQL();
	$db_list->DBType       = $db->DBType;
	$db_list->DBDatabase   = $db->DBDatabase;
	$db_list->DBUser       = $db->DBUser;
	$db_list->DBPassword   = $db->DBPassword;
	$db_list->DBHost       = $db->DBHost;
	$db_list->DBPort       = $db->DBPort;
	$db_list->DBPersistent = $db->DBPersistent;

	$language_code = get_session("session_language_code");

	$i = 0;
	if(is_array($values_before))
	{
		for($j = 0; $j < sizeof($values_before); $j++)
		{
			$values[$i][0] = $values_before[$j][0];
			$values[$i][1] = get_translation($values_before[$j][1], $language_code);
			$i++;
		}
	}

	$db_list->query($sql);
	if($db_list->next_record())
	{
		do
		{
			$value_desciption = get_translation($db_list->f(1), $language_code);
			if ($shown_symbols > 0 && strlen($value_desciption) > $shown_symbols) {
				$value_desciption = substr($value_desciption, 0, $shown_symbols) . "...";
			}
			$values[$i][0] = $db_list->f(0);
			$values[$i][1] = $value_desciption;
			$i++;
		} while ($db_list->next_record());
	}

	return $values;
}

function get_setting_value($settings_array, $setting_name, $default_value = "")
{
	return (is_array($settings_array) && isset($settings_array[$setting_name]) && strlen($settings_array[$setting_name])) ? $settings_array[$setting_name] : $default_value;
}

function get_meta_desc($meta_description)
{
	$meta_description = strip_tags($meta_description);
	if (strlen($meta_description) > 255) {
		$meta_description = substr($meta_description, 0, 250) . " ...";
	}
	$meta_description = str_replace("\"", "&quot;", $meta_description);
	return $meta_description;
}

function get_eol() 
{
	if (strtoupper(substr(PHP_OS,0,3)=='WIN')) { 
		$eol = "\r\n"; 
	} else if (strtoupper(substr(PHP_OS,0,3)=='MAC')) { 
		$eol = "\r"; 
	} else { 
		$eol = "\n"; 
	}  
	return $eol;
}

function get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type)
{
	$mail_headers  = "";

	$eol = get_eol();

	if ($mail_from) { $mail_headers .= "From: " . $mail_from . $eol; }
	if ($mail_cc)  { 
		$mail_cc = str_replace(";", ",", $mail_cc);
		$mail_headers .= "cc: " . $mail_cc . $eol; 
	}
	if ($mail_bcc)  { 
		$mail_bcc = str_replace(";", ",", $mail_bcc);
		$mail_headers .= "Bcc: " . $mail_bcc . $eol; 
	}
	if ($mail_reply_to) { $mail_headers .= "Reply-To: " . $mail_reply_to . $eol; }
	if ($mail_return_path)  { $mail_headers .= "Return-path: " . $mail_return_path . $eol; }
	$mail_headers .= "MIME-Version: 1.0";
	if (strlen($mail_type)) {
		$mail_headers .= ($mail_type) ? $eol . "Content-Type: text/html": $eol . "Content-Type: text/plain";
	}

	return $mail_headers;
}

function strip($value)
{
  if(get_magic_quotes_gpc() == 0)
    return $value;
  else
    return stripslashes($value);
}

function call_event($events, $event_name, $additional_parameters = "")
{
	if (is_array($events) && isset($events[$event_name]) && function_exists($events[$event_name])) {
		if (isset($events[$event_name . "_params"]) && is_array($events[$event_name . "_params"])) {
			$event_parameters = $events[$event_name . "_params"];
		} else {
			$event_parameters = array();
		}
		if (is_array($additional_parameters)) {
			foreach ($additional_parameters as $key => $value) {
				$event_parameters[$key] = $value;
			}
		}
		call_user_func($events[$event_name], $event_parameters);
	}
}

function get_db_value($sql)
{
	global $db;

	$db->query($sql);
	if ($db->next_record()) {
		return $db->f(0);
	} else  {
		return "";
	}
}

function get_page_url()
{
	$server_name = getenv("SERVER_NAME");
	$request_uri = getenv("REQUEST_URI");
}

function get_script_name()
{
	global $current_page;
	if (isset($current_page) && $current_page) {
		$script_name = $current_page;
	} else if (get_var("PHP_SELF")) {
		$script_name = get_var("PHP_SELF");
	} else if (get_var("SCRIPT_NAME")) {
		$script_name = get_var("SCRIPT_NAME");
	} else if (get_var("SCRIPT_FILENAME")) {
		$script_name = get_var("SCRIPT_FILENAME");
	} else if (get_var("REQUEST_URI")) {
		$script_name = get_var("REQUEST_URI");
	} else {
		$script_name = get_var("SCRIPT_URL");
	}

	return basename($script_name);
}

function get_request_page()
{
	global $current_page;
	$request_page = get_var("REQUEST_URI");
	$request_page = preg_replace("/\?.*$/", "", $request_page);
	if (!$request_page || substr($request_page, -1) == "/") {
		if (get_var("SCRIPT_URL")) {
			$request_page = get_var("SCRIPT_URL");
		} else if (isset($current_page) && $current_page) {
			$request_page = $current_page;
		} else if (get_var("SCRIPT_NAME")) {
			$request_page = get_var("SCRIPT_NAME");
		} else if (get_var("PHP_SELF")) {
			$request_page = get_var("PHP_SELF");
		}
	}

	return basename($request_page);
}

function get_request_uri()
{
	$request_uri = get_var("REQUEST_URI");
	if (!strlen($request_uri)) {
		$request_uri = get_var("SCRIPT_NAME");
		if (!$request_uri) { $request_uri = get_var("SCRIPT_URL"); }
		if (!$request_uri) { $request_uri = get_var("PHP_SELF"); }
		$query_string = get_var("QUERY_STRING");
		if (strlen($query_string)) {
			$request_uri .= "?" . $query_string;
		}
	}
	return $request_uri;
}

function check_user_session()
{
  if (!strlen(get_session("session_user_id"))) {
		$request_uri = get_request_uri();
		header ("Location: user_login.php?return_page=" . urlencode($request_uri) . "&type_error=1");
		exit;
	}
}

function check_black_ip($ip_address = "", $address_action = 1)
{
	global $db, $table_prefix;

	if (!$ip_address) {
		$ip_address = get_ip();
	}
	$ip_parts = explode(".", $ip_address);
	$where = " WHERE address_action=" . $db->tosql($address_action, INTEGER) . " AND ("; 
	$ip_where = "";
	for ($i = 0; $i < sizeof($ip_parts); $i++) {
		if ($i) { 
			$ip_where .= ".";
			$where .= " OR "; 
		}
		$ip_where .= $ip_parts[$i];
		$where .= " ip_address=" . $db->tosql($ip_where, TEXT);
	}
	$where .= ") ";
	$sql = " SELECT COUNT(*) FROM ".$table_prefix."black_ips " . $where;

	$black_ips = get_db_value($sql);

	return $black_ips;
}

function check_banned_content($message)
{
	global $db, $table_prefix;

	$is_banned = false; $banned_regexp = "";
	$sql = " SELECT content_text FROM ".$table_prefix."banned_contents ";
	$db->query($sql);
	while ($db->next_record()) {
		if ($banned_regexp) { $banned_regexp .= "|"; }
		$content_text = $db->f("content_text");
		$banned_regexp .= "(" . prepare_regexp($content_text) . ")";
	}

	if ($banned_regexp) {
		$is_banned = preg_match("/".$banned_regexp."/is", $message);
	}

	return $is_banned;
}

function hmac_md5 ($data, $key)
{
	// RFC 2104 HMAC implementation for php.
	// Creates an md5 HMAC.
 
	$b = 64; // byte length for md5
	if (strlen($key) > $b) {
		$key = pack("H*",md5($key));
	}
	$key  = str_pad($key, $b, chr(0x00));
	$ipad = str_pad('', $b, chr(0x36));
	$opad = str_pad('', $b, chr(0x5c));
	$k_ipad = $key ^ $ipad ;
	$k_opad = $key ^ $opad;

	return md5($k_opad  . pack("H*",md5($k_ipad . $data)));
}

function set_categories($parent_id, $level, $columns, $top_id, $image_type = 1) 
{
	global $t, $categories, $category_number, $restrict_categories_images, $settings, $page_settings, $category_id;
	global $list_url, $list_page;

	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");

	$tw = 14; $th = 20;
	if (file_exists("images/".$settings["style_name"]."/tree_space.gif")) {
		$image_tree_space = "images/".$settings["style_name"]."/tree_space.gif";
		$image_tree_line = "images/".$settings["style_name"]."/tree_line.gif";
		$image_tree_begin = "images/".$settings["style_name"]."/tree_begin.gif";
		$image_tree_end = "images/".$settings["style_name"]."/tree_end.gif";
		$image_tree_top = "images/".$settings["style_name"]."/tree_top.gif";
	} else {
		$image_tree_space = "images/tree_space.gif";
		$image_tree_line = "images/tree_line.gif";
		$image_tree_begin = "images/tree_begin.gif";
		$image_tree_end = "images/tree_end.gif";
		$image_tree_top = "images/tree_top.gif";
	}

	$subs = isset($categories[$parent_id]) ? $categories[$parent_id]["subs"] : array();
	for ($i = 0; $i < sizeof($subs); $i++)
	{
		$category_number++;
		$show_category_id = $subs[$i];
		$category_name  = $categories[$show_category_id]["category_name"];
		$friendly_url = $categories[$show_category_id]["friendly_url"];
		if ($friendly_urls && $friendly_url) {
			$list_url->remove_parameter("category_id");
			$t->set_var("list_url", $list_url->get_url($friendly_url . $friendly_extension));
		} else {
			$list_url->add_parameter("category_id", CONSTANT, $show_category_id);
			$t->set_var("list_url", $list_url->get_url($list_page));
		}
		if ($image_type == 2) {
			$category_image = $categories[$show_category_id]["image"];
		} else {
			$category_image = $image_tree_top;
		}
		$image_alt = $categories[$show_category_id]["image_alt"];
		$short_description = $categories[$show_category_id]["short_description"];
		$is_rss = isset($categories[$show_category_id]["is_rss"]) ? $categories[$show_category_id]["is_rss"] : false;
		if ($i == sizeof($subs) - 1) {
			$categories[$show_category_id]["last"] = true;
		} else {
			$categories[$show_category_id]["last"] = false;
		}

		$t->set_var("category_id", $show_category_id);

		$tree_images = "";
		if ($parent_id != $top_id) {
			$tree_id = $parent_id; 
			if (isset($categories[$tree_id]["parent_id"])) {
				while ($categories[$tree_id]["parent_id"] != $top_id) {
					if ($categories[$tree_id]["last"]) {
						$tree_image = $image_tree_space;
					} else {
						$tree_image = $image_tree_line;
					}
					$tree_images = "<img border=0 align=left src=$tree_image hspace=0 width=$tw height=$th>" . $tree_images;
					$tree_id = $categories[$tree_id]["parent_id"];
				}
			}
		}
		if ($level > 0) {
			if ($categories[$show_category_id]["last"]) {
				$tree_images .= "<img border=0 align=left src=$image_tree_end hspace=0 width=$tw height=$th>"; 
			} else {
				$tree_images .= "<img border=0 align=left src=$image_tree_begin hspace=0 width=$tw height=$th>"; 
			}
			$t->set_var("category_tr_class", "subCategory");
		} else {
			$t->set_var("category_tr_class", "topCategory");
		}
		if ($show_category_id == $category_id) {
			if ($level > 0) {
				$t->set_var("category_tr_class", "selectedsubCategory");
			} else {
				$t->set_var("category_tr_class", "selectedtopCategory");
			}
		}

		$t->set_var("category_name", $tree_images . $category_name);
		if ($is_rss) {
			$t->parse("category_rss", false);
		} else {
			$t->set_var("category_rss", "");
		}
		if ($level > 0 || !$category_image) {
			$t->set_var("alt", "");
			$t->set_var("src", "images/tr.gif");
			$t->set_var("width", "width=\"1\"");
			$t->set_var("height", "height=\"1\"");
			$t->parse("category_image", false);
		} else {
			if (preg_match("/^http\:\/\//", $category_image)) {
				$image_size = "";
			} else {
				$image_size = @GetImageSize($category_image);
				if (isset($restrict_categories_images) && $restrict_categories_images) { 
					$category_image = "image_show.php?category_id=".$show_category_id;
				}
			}
			if (!strlen($image_alt)) { $image_alt = $category_name; }
			$t->set_var("alt", htmlspecialchars($image_alt));
			$t->set_var("src", htmlspecialchars($category_image));
			if(is_array($image_size))
			{
				$t->set_var("width", "width=\"" . $image_size[0] . "\"");
				$t->set_var("height", "height=\"" . $image_size[1] . "\"");
			}
			else
			{
				$t->set_var("width", "");
				$t->set_var("height", "");
			}
			$t->parse("category_image", false);
		}
		$t->parse("categories");
		if($category_number % $columns == 0)
		{
			$t->parse("categories_rows");
			$t->set_var("categories", "");
		}
		if (isset($categories[$show_category_id]["subs"]) && is_array($categories[$show_category_id]["subs"])) {
			set_categories($show_category_id, $level + 1, $columns, $top_id, $image_type);
		}

	}
}

function process_message($message, $level_colors = "") 
{
	$eol = get_eol();
	// set level colors
	if (!is_array($level_colors)) {
		$level_colors = array(
			"0"=>"black", "1"=>"blue", "2"=>"red", "3"=>"green", "4"=>"gray", "5"=>"navy", "6"=>"olive", "7"=>"brown", "8"=>"purple"
		);
	}

	$message = preg_replace("/</","&lt;",$message);
	$message = preg_replace("/!^>/","&gt;",$message);
	$message = str_replace("\r","", $message);
	$msg_strings = split("\n", $message);
	$message     = "";
	$last_level  = 0;
	$ln = 0;

	$message .= "<div style='color:".$level_colors[0].";'>";
	foreach ($msg_strings as $line) {
		$ln++;
		//-- get current level
		if (preg_match("/^>+/", $line, $match)) {
			$cur_level = strlen($match[0]);
		} else {
			$cur_level = 0;
		}
		$line = preg_replace("/^>+/","",$line);
		if (!trim($line)) $line="&nbsp;";
		$level_diff = $last_level - $cur_level;
		if ($level_diff > 0) {
			$tags = "";
			for($t = 1; $t <= $level_diff; $t++) {
				$tags .="</div>" . $eol;
			}
			$line = $tags . $line;
		} else if ($level_diff < 0) {
			$tags = "";
		  for ($t = $last_level; $t < $cur_level; $t++) {         	
  		  $tags .="<div style='color:". $level_colors[($t + 1) % 9] ."; margin-left: 5pt; padding-left: 5pt; border-left-style:solid; border-left-width:thin;'>" . $eol;
		  }
			$line = $tags.$line;
		} else {
			if ($ln > 1) {
				$line = "<br>" . $line;
			}
		}
		$last_level = $cur_level;
		$message .= $line;
	}
	
	//-- add end tags
	$tags = "";
	for($t = 1; $t <= $last_level; $t++) {
		$tags .="</div>" . $eol;
	}
	$message .= $tags . "</div>";

	return $message;
}

function get_tax_amount($tax_rates, $item_type_id, $price, $tax_free) 
{
	$tax_amount = 0; $tax_percent = 0;
	if (!$tax_free) {
		if (isset($tax_rates[$item_type_id]) && strlen($tax_rates[$item_type_id])) {
			$tax_percent = $tax_rates[$item_type_id];
		} else if (isset($tax_rates[0]) && strlen($tax_rates[0])) {
			$tax_percent = $tax_rates[0];
		}
	}
	$tax_amount = round(($price * $tax_percent) / 100, 2);

	return array($tax_percent, $tax_amount);
}

function check_image_validation($validation_number)
{
	$session_random_arr = get_session("session_random_arr");
	if(strlen($validation_number) == 0 || !in_array($validation_number, $session_random_arr)) {
		return false;
	} else {
		unset($session_random_arr[array_search($validation_number, $session_random_arr)]);
		set_session("session_random_arr", $session_random_arr);
		return true;
	}
}

function get_nice_bytes($bytes)
{
  if ($bytes >= 1024 && $bytes < 1048576) { 
		return round($bytes / 1024) . "Kb";
	} else if ($bytes >= 1048576) { 
		return round($bytes / 1048576, 1) . "Mb";
	} else { 
		return $bytes." bytes";
	}
}

?>